/**********************************************************************
 *<
	FILE: MirrorTVs.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#include "MirrorTVs.h"



static GenSubObjType SOT_Points(13);

int sMyEnumProc::proc(ReferenceMaker *rmaker) 
	{ 
	if (rmaker->SuperClassID()==BASENODE_CLASS_ID)    
			{
            Nodes.Append(1, (INode **)&rmaker);                 
			}
     return 0;              
	}

FaceRadixData::FreeFaceElementList()
{
	for (int i = 0; i < faceElements.Count(); i++)
		delete faceElements[i];
	faceElements.ZeroCount();
}

FaceElement *FaceRadixData::GetElementList(float val, int &count)
{
	int index = (val+min)/divisor;
	if (index < 0) index = 0;
	if (index >= count) index = count-1;
	count = faceElements[index]->data.Count();
	return faceElements[index]->data.Addr(0);
}

FaceRadixData::BuildRadixData(float threshold, int count, FaceElement *data)
{
	FreeFaceElementList();
	//find the min and max value
	if (count <2 ) return 0 ;
	min = data[0].val;
	max = data[0].val;
	for (int i = 1; i < count; i++)
		{
		if (data[i].val < min) min = data[i].val;
		if (data[i].val > max) max = data[i].val;
		}
	//compute divisor
	
	float span = max - min;
	int numberCells = span/threshold;
	divisor = span/numberCells;

	//build the cells
	faceElements.SetCount(numberCells);
	for (i = 0; i < numberCells; i++)
		{
		faceElements[i] = new FaceElementList2();
		}
	for (i = 0; i < count; i++)
		{
		int index = (data[i].val+min)/divisor;
		if (index < 0) index = 0;
		if (index >= count) index = count-1;

		FaceElement temp;
		temp.index = data[i].index;
		temp.val = data[i].val;
		faceElements[index]->data.Append(1,&temp,100);
		}
	DebugPrint("number Cells %d\n",numberCells);
	for (i = 0; i < numberCells; i++)
		{

		}
	return 1;
}



static MirrorTVsClassDesc MirrorTVsDesc;
ClassDesc2* GetMirrorTVsDesc() { return &MirrorTVsDesc; }



static ParamBlockDesc2 mirrortvs_param_blk ( mirrortvs_params, _T("params"),  0, &MirrorTVsDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	// params
	pb_mapchannel, 			_T("channel"), 		TYPE_INT, 	0, 	IDS_CHANNEL, 
		p_default, 		1, 
		p_range, 		0,99, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_INT, IDC_CHANNEL,	IDC_CHANNELSPIN, 0.01f, 
		end,

	pb_axis,	_T("axis"),	TYPE_INT,	0,	IDS_AXIS,
	// optional tagged param specs
		p_default,		kX,
		p_ui,			TYPE_INTLISTBOX, IDC_AXISCOMBO, 3,
						IDS_X, IDS_Y, IDS_Z,
		p_vals,			kX,kY,kZ,
		end,


	pb_offset, 			_T("offset"), 		TYPE_FLOAT, 	0, 	IDS_OFFSET, 
		p_default, 		0.0f, 
		p_range, 		-100000.0f,100000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_OFFSET,	IDC_OFFSETSPIN, 0.01f, 
		end,

	pb_threshold, 			_T("threshold"), 		TYPE_FLOAT, 	0, 	IDS_THRESHOLD, 
		p_default, 		0.001f, 
		p_range, 		0.0f,100.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_THRESHOLD,	IDC_THRESHOLDSPIN, 0.01f, 
		end,

	pb_usenode, 	_T("useNode"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PW_USENODE,
		p_default, 		FALSE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_NODEPLANE, 
		end, 

	pb_node, 	_T("node"),		TYPE_INODE, 		0,				IDS_PW_NODE,
		p_ui, 			TYPE_PICKNODEBUTTON, 	IDC_NODEPLANE_BUTTON, 
		end, 

	pb_copymatids, 	_T("copyMatIDs"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PW_COPYMATIDS,
		p_default, 		TRUE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_MATIDS_CHECK, 
		end, 

	pb_copysmoothinggroups, 	_T("copySmoothingGroups"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PW_COPYSMG,
		p_default, 		TRUE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_SMG_CHECK, 
		end, 

	pb_instanceuvs, 	_T("instanceUVs"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PW_INSTANCEUVS,
		p_default, 		TRUE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_INSTANCETVS_CHECK, 
		end, 

	pb_copystrayverts, 	_T("instanceUVs"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PW_INSTANCEUVS,
		p_default, 		TRUE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_COPYSTRAYVERTS_CHECK, 
		end, 

	
	end
	);




IObjParam *MirrorTVs::ip			= NULL;




//--- MirrorTVs -------------------------------------------------------
MirrorTVs::MirrorTVs()
{
	MirrorTVsDesc.MakeAutoParamBlocks(this);
}

MirrorTVs::~MirrorTVs()
{
}

/*===========================================================================*\
 |	The validity of the parameters.  First a test for editing is performed
 |  then Start at FOREVER, and intersect with the validity of each item
\*===========================================================================*/
Interval MirrorTVs::LocalValidity(TimeValue t)
{
	// if being edited, return NEVER forces a cache to be built 
	// after previous modifier.
	if (TestAFlag(A_MOD_BEING_EDITED))
		return NEVER;  
	//TODO: Return the validity interval of the modifier
	return NEVER;
}


/*************************************************************************************************
*
	Between NotifyPreCollapse and NotifyPostCollapse, Modify is
	called by the system.  NotifyPreCollapse can be used to save any plugin dependant data e.g.
	LocalModData
*
\*************************************************************************************************/

void MirrorTVs::NotifyPreCollapse(INode *node, IDerivedObject *derObj, int index)
{
	//TODO:  Perform any Pre Stack Collapse methods here
}



/*************************************************************************************************
*
	NotifyPostCollapse can be used to apply the modifier back onto to the stack, copying over the
	stored data from the temporary storage.  To reapply the modifier the following code can be 
	used

	Object *bo = node->GetObjectRef();
	IDerivedObject *derob = NULL;
	if(bo->SuperClassID() != GEN_DERIVOB_CLASS_ID)
	{
		derob = CreateDerivedObject(obj);
		node->SetObjectRef(derob);
	}
	else
		derob = (IDerivedObject*) bo;

	// Add ourselves to the top of the stack
	derob->AddModifier(this,NULL,derob->NumModifiers());

*
\*************************************************************************************************/

void MirrorTVs::NotifyPostCollapse(INode *node,Object *obj, IDerivedObject *derObj, int index)
{
	//TODO: Perform any Post Stack collapse methods here.

}


Matrix3 MirrorTVs::CompMatrix(TimeValue t,INode *inode,ModContext *mc)
	{
	Interval iv;
	Matrix3 tm(1);	
//	if (mc && mc->tm) tm = Inverse(*(mc->tm));
	if (inode) 
		{
		tm = tm * inode->GetObjTMBeforeWSM(t,&iv);
		}
	return tm;
	}


int MirrorTVs::Display(TimeValue t, INode* inode, ViewExp *vpt, int flagst, ModContext *mc)
/*
int MirrorTVs::Display(
		TimeValue t, INode* inode, ViewExp *vpt, 
		int flagst, ModContext *mc)*/
	{
	GraphicsWindow *gw = vpt->getGW();
	Point3 pt[4];
	Matrix3 tm = CompMatrix(t,inode,mc);
	int savedLimits;

	gw->setRndLimits((savedLimits = gw->getRndLimits()) & ~GW_ILLUM);

	if (useDrawTM)
		gw->setTransform(drawTM);
	else gw->setTransform(tm);
	
	// Draw start point
	gw->setColor(LINE_COLOR,GetUIColor(COLOR_GIZMOS));

	Box3 b;
	b.Init();
	for (int i = 0; i < mirrorVerts.Count(); i++)
		{	
		if (displayVerts[i])
			{
			gw->marker(&mirrorVerts[i],HOLLOW_BOX_MRKR);
			b += mirrorVerts[i];
			}
		}


	gw->setColor(LINE_COLOR,GetUIColor(COLOR_SEL_GIZMOS));
	
	for (i = 0; i < strayDisplayVerts.Count(); i++)
		{	
		gw->marker(&strayDisplayVerts[i],PLUS_SIGN_MRKR);
		}

	

	float offset;
	int axis;
	Interval iv;

	pblock->GetValue(pb_axis,t,axis,iv);
	pblock->GetValue(pb_offset,t,offset,iv);

	float dist = Length(b.Width())*0.5f;
	
	Point3 center(0.0f,0.0f,0.0f);

	

	if (axis==kX)
		{
		center.x = offset;

		pt[0] = center;
		pt[1] = center;

		pt[0].y -= dist;
		pt[0].z -= dist;
		pt[1].y += dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);


		pt[0] = center;
		pt[1] = center;

		pt[0].y -= dist;
		pt[0].z += dist;
		pt[1].y += dist;
		pt[1].z += dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].y -= dist;
		pt[0].z += dist;
		pt[1].y -= dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].y += dist;
		pt[0].z += dist;
		pt[1].y += dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);


		}
	else if (axis==kY)
		{
		center.y = offset;

		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].z -= dist;
		pt[1].x += dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);


		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].z += dist;
		pt[1].x += dist;
		pt[1].z += dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].z += dist;
		pt[1].x -= dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].x += dist;
		pt[0].z += dist;
		pt[1].x += dist;
		pt[1].z -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);
		}
	else if (axis==kZ)
		{
		center.z = offset;

		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].y -= dist;
		pt[1].x += dist;
		pt[1].y -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);


		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].y += dist;
		pt[1].x += dist;
		pt[1].y += dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].x -= dist;
		pt[0].y += dist;
		pt[1].x -= dist;
		pt[1].y -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);

		pt[0] = center;
		pt[1] = center;

		pt[0].x += dist;
		pt[0].y += dist;
		pt[1].x += dist;
		pt[1].y -= dist;
		gw->polyline(2, pt, NULL, NULL, 0, NULL);
		}

	gw->setColor(TEXT_COLOR,GetUIColor(COLOR_GIZMOS));
	for (i = 0; i < mirrorFaces.Count(); i++)
		{
		pt[0] = mirrorFaces[i].mapA;
		pt[1] = mirrorFaces[i].mapB;
		pt[2] = mirrorFaces[i].mapC;

		gw->polyline(2, pt, NULL, NULL, 0, NULL);
		}


	gw->setRndLimits(savedLimits);

	return 0;
	}


/*************************************************************************************************
*
	ModifyObject will do all the work in a full modifier
    This includes casting objects to their correct form, doing modifications
	changing their parameters, etc
*
\************************************************************************************************/


void MirrorTVs::ModifyObject(TimeValue t, ModContext &mc, ObjectState * os, INode *node) 
{
	//TODO: Add the code for actually modifying the object
	if (os->obj->IsSubClassOf(triObjectClassID)) {



		TriObject *tobj = (TriObject*)os->obj;
		Mesh &mesh = tobj->GetMesh();
		Interval iv = FOREVER;

		int channel;
		float threshold, offset;
		int axis;

		pblock->GetValue(pb_mapchannel,t,channel,iv);
		pblock->GetValue(pb_axis,t,axis,iv);
		pblock->GetValue(pb_threshold,t,threshold,iv);
		pblock->GetValue(pb_offset,t,offset,iv);

		
		BOOL copyMatIDs,copySmoothingGroups,instanceUVs,copyStrayVerts;
		pblock->GetValue(pb_copymatids,t,copyMatIDs,iv);
		pblock->GetValue(pb_copysmoothinggroups,t,copySmoothingGroups,iv);
		pblock->GetValue(pb_instanceuvs,t,instanceUVs,iv);
		pblock->GetValue(pb_copystrayverts,t,copyStrayVerts,iv);

		INode *mirrorNode = NULL;
		INode *selfNode = NULL;
		BOOL useNode = FALSE;
		pblock->GetValue(pb_usenode,t,useNode,iv);
		pblock->GetValue(pb_node,t,mirrorNode,iv);
		Matrix3 toWorld(1);
		Matrix3 toMirrorSpace(1);

		useDrawTM = FALSE;

		if ((useNode) && (mirrorNode))
			{
//get self node
			sMyEnumProc dep;              
			EnumDependents(&dep);
			if (dep.Nodes.Count() > 0)
				selfNode = dep.Nodes[0];
			if (selfNode == NULL)
				{
				useNode = FALSE;
				}
			else
				{
				toWorld = selfNode->GetObjectTM(t,&FOREVER);
//get mirror tm
				Matrix3 mirrorTM = mirrorNode->GetObjectTM(t,&FOREVER);
				toMirrorSpace = Inverse(mirrorTM);
				useDrawTM = TRUE;
				drawTM = mirrorTM;;

				}
//get se	lf tm
			}

		Matrix3 tm = toWorld*toMirrorSpace;
		Matrix3 backtm  = Inverse(tm);




		TVFace *tvFaces = mesh.mapFaces(channel);

		if ((mesh.selLevel == MESH_FACE) && ( mesh.faceSel.NumberSet() > 0) && (tvFaces))
			{



			//get our face selection
			BitArray faceSel(mesh.faceSel);

	//get all vertices that are attached to the face selection
	//get the vertex list
			int numFaces, numVerts;
			numFaces = mesh.numFaces;
			numVerts = mesh.numVerts;
			Tab<Point3> verts;// = mesh.verts;
			verts.SetCount(numVerts);

			for (int i =0; i < numVerts; i++)
				verts[i] = mesh.verts[i] * tm;

			BitArray vertsToBeProcessed;
			vertsToBeProcessed.SetSize(numVerts);
			vertsToBeProcessed.ClearAll();

			displayVerts.SetSize(numVerts);
			displayVerts.ClearAll();


			for (i =0; i < numFaces; i++)
				{
				if (faceSel[i])
					{
					int a = mesh.faces[i].v[0];
					vertsToBeProcessed.Set(a);
					a = mesh.faces[i].v[1];
					vertsToBeProcessed.Set(a);
					a = mesh.faces[i].v[2];
					vertsToBeProcessed.Set(a);
					}
				}

			displayVerts = vertsToBeProcessed;
		//mirror our processed vertices and build a mirror list
//			Tab<Point3> mirrorVerts;
			mirrorVerts.SetCount(numVerts);
			mirrorFaces.ZeroCount();

			for (i =0; i < numVerts; i++)
				{
				Point3 p = verts[i];
				if (axis == kX)
					p.x = p.x - (p.x - offset)*2.0f;
				else if (axis == kY)
					p.y = p.y - (p.y - offset)*2.0f;
				else if (axis == kZ)
					p.z = p.z - (p.z - offset)*2.0f;
				mirrorVerts[i] = p;
				}

			//now tag faces that match the mirror data
			Tab<Face> mirrorFaceList;
			mirrorFaceList.SetCount(numFaces);
			
			Tab<float> faceReducerList;
			faceReducerList.SetCount(numFaces);
			//put in a radix or some other bucket system so we can look these up faster later
			for (i =0; i < numFaces; i++)
				{
				float sum = 0;
				faceReducerList[i] = 0.0f;
				for (int j = 0; j < 3; j++)
					{
					int a = mesh.faces[i].v[j];
					sum += verts[a].x;
					sum += verts[a].y;
					sum += verts[a].z;
					}
				faceReducerList[i] = sum;
				}

//first see if we can find a 1 to 1 face correspondance
			
			for (i =0; i < numFaces; i++)
				{
				if (faceSel[i])
					{
					float sum = 0.0f;
					Point3 pmArray[3];
					for (int j = 0; j < 3; j++)
						{
						int a = mesh.faces[i].v[j];
						pmArray[j] = mirrorVerts[a];
						sum += pmArray[j].x;
						sum += pmArray[j].y;
						sum += pmArray[j].z;
						}
//find potential matching faces
					Tab<int> hitFaces;
					for (j =0; j < numFaces; j++)
						{
						if ((fabs(sum - faceReducerList[j]) <= threshold) && (!faceSel[j]))
							hitFaces.Append(1,&j,10);
						}

					if (hitFaces.Count() > 0)
						{
						sum = -1.0f;
						int closestFace;
						int indexOrder[3];
						for (j =0; j < hitFaces.Count(); j++)
							{
							Point3 pArray[3];
							int index = hitFaces[j];
							pArray[0] = verts[mesh.faces[index].v[0]];
							pArray[1] = verts[mesh.faces[index].v[1]];
							pArray[2] = verts[mesh.faces[index].v[2]];

							int closest[3];
							closest[0] = -1;
							closest[1] = -1;
							closest[2] = -1;

							for (int k = 0; k < 3; k++)
								{
								Point3 pm = pmArray[k];
								float d = -1.0f;
								for (int m = 0; m < 3; m++)
									{
									Point3 p = pArray[m];
									float dist = Length(p-pm);
									if ((d < 0.0f) || (dist < d))
										{
										d= dist;
										closest[k] = m;
										}
									}
								}	
							float totalD = 0.0f;
							for (k = 0; k < 3; k++)
								{
								Point3 pm = pmArray[k];
								Point3 p = verts[mesh.faces[index].v[closest[k]]];
								totalD += Length(pm-p);
								}
							if ((sum == -1.0f) || (totalD<sum))
								{
								sum = totalD;
								closestFace = index;
								indexOrder[0] = closest[0];
								indexOrder[1] = closest[1];
								indexOrder[2] = closest[2];
								}
							}
						MirroredFace tempMFace;
						tempMFace.index = i;
						tempMFace.mirrorIndex = closestFace;
						tempMFace.order[0] = indexOrder[0];
						tempMFace.order[1] = indexOrder[1];
						tempMFace.order[2] = indexOrder[2];

						int a,b,c;
//				a = mesh.faces[i].v[0];
//				b = mesh.faces[i].v[1];
//				c = mesh.faces[i].v[2];

						a = mesh.faces[closestFace].v[0];
						b = mesh.faces[closestFace].v[1];
						c = mesh.faces[closestFace].v[2];
						tempMFace.mapA = verts[a];
						tempMFace.mapB = verts[b];
						tempMFace.mapC = verts[c];

						mirrorFaces.Append(1,&tempMFace,100);
						}
					}

				}
//process left over faces that dont match but that could match vertices



	//loop through selected faces and look for matches
			BitArray newTVVerts;
			newTVVerts.SetSize(mesh.getNumMapVerts(channel));
			newTVVerts.ClearAll();
			for (i =0; i < mirrorFaces.Count(); i++)
				{
				int index = mirrorFaces[i].mirrorIndex;
				int a = tvFaces[index].t[0];
				newTVVerts.Set(a);
				a = tvFaces[index].t[1];
				newTVVerts.Set(a);
				a = tvFaces[index].t[2];
				newTVVerts.Set(a);
				}

			Tab<int> extraUVs;
			Tab<Point3> newVerts;
			newVerts.SetCount(newTVVerts.NumberSet());
			extraUVs.SetCount(mesh.getNumMapVerts(channel));
			int ct = mesh.getNumMapVerts(channel);
			int nct = 0;
			Point3 *uvw = mesh.mapVerts(channel);
			for (i =0; i < mesh.getNumMapVerts(channel); i++)
				{
				extraUVs[i] = -1;
				if (newTVVerts[i])
					{
					extraUVs[i] = ct;
					newVerts[nct] = uvw[i];
//DebugPrint("orig vert %d new verts %d\n",i,ct);
					nct++;
					ct++;
					}
				}
			//append uvs
			//set new tv faces
			int oldTVCount = mesh.getNumMapVerts(channel);
			mesh.setNumMapVerts(channel,oldTVCount+newVerts.Count() , TRUE);
			ct = 0;
			for (i = oldTVCount; i < mesh.getNumMapVerts(channel); i++)
				{
				mesh.setMapVert(channel, i, newVerts[ct]);
//DebugPrint("%d vert %f %f %f\n",i,newVerts[ct].x,newVerts[ct].y,newVerts[ct].z);
				ct++;
				}
//fix this
			for (i =0; i < mirrorFaces.Count(); i++)
				{
				int index = mirrorFaces[i].index;
				int mappedIndex = mirrorFaces[i].mirrorIndex;
				int order = mirrorFaces[i].order[0];
				int a = tvFaces[mappedIndex].t[0];
				int nUVW = extraUVs[a];
//DebugPrint("face %d index vert %d",a,nUVW);
				if (instanceUVs)
					tvFaces[index].t[order] = tvFaces[mappedIndex].t[0];
				else tvFaces[index].t[order] = nUVW;//tvFaces[mappedIndex].t[0];

				order = mirrorFaces[i].order[1];
				a = tvFaces[mappedIndex].t[1];
				nUVW = extraUVs[a];
				if (instanceUVs)
					tvFaces[index].t[order] = tvFaces[mappedIndex].t[1];
				else tvFaces[index].t[order] = nUVW;//tvFaces[mappedIndex].t[1];;
//DebugPrint(" %d",nUVW);

				order = mirrorFaces[i].order[2];
				a = tvFaces[mappedIndex].t[2];;
				nUVW = extraUVs[a];
				if (instanceUVs)
					tvFaces[index].t[order] = tvFaces[mappedIndex].t[2];
				else tvFaces[index].t[order] = nUVW;//tvFaces[mappedIndex].t[2];;
//DebugPrint(" %d\n",nUVW);

				if (copyMatIDs)
					mesh.faces[index].setMatID(mesh.faces[mappedIndex].getMatID());
				if (copySmoothingGroups)
					mesh.faces[index].setSmGroup(mesh.faces[mappedIndex].getSmGroup());

				faceSel.Set(index,FALSE);
/*				a = mesh.faces[index].v[0];
				vertsToBeProcessed.Set(a,FALSE);
				a = mesh.faces[index].v[1];
				vertsToBeProcessed.Set(a,FALSE);
				a = mesh.faces[index].v[2];
				vertsToBeProcessed.Set(a,FALSE);
*/

				}

			strayDisplayVerts.ZeroCount();

			if ((copyStrayVerts) && (faceSel.NumberSet() > 0))
				{
				uvw = mesh.mapVerts(channel);

				Tab<Point3> gUVWs;
				gUVWs.SetCount(numVerts);
				BitArray usedgUVWs;
				usedgUVWs.SetSize(numVerts);
				usedgUVWs.ClearAll();

				BitArray ignoreFaces;
				ignoreFaces.SetSize(numFaces);
				ignoreFaces.ClearAll();

				BOOL posSide = TRUE;

				int posCount=0,negCount=0;
				for (i =0; i < numFaces; i++)
					{
					if (faceSel[i])
						{
						for (int j = 0; j < 3; j++)
							{
							int a = mesh.faces[i].v[j];
							Point3 p = verts[a];
							if (axis == kX) 
								{
								if (p.x > (offset+0.001f))
									posCount++;
								else if (p.x < (offset-0.001f)) negCount++;
								}
							else if (axis == kY) 
								{
								if (p.y > (offset+0.001f))
									posCount++;
								else if (p.y < (offset-0.001f)) negCount++;
								}
							else if (axis == kZ) 
								{
								if (p.z > (offset+0.001f))
									posCount++;
								else if (p.z < (offset-0.001f))
									negCount++;
								}

							}
						}

					}
				if (negCount > posCount)
					posSide = FALSE;

				for (i =0; i < numFaces; i++)
					{
					if (!faceSel[i])
						{
						for (int j = 0; j < 3; j++)
							{
							int a = mesh.faces[i].v[j];
							Point3 p = verts[a];
							if (posSide)
								{
								if ((axis == kX) && (p.x > (offset+0.001f)))
									ignoreFaces.Set(i);
								else if ((axis == kY) && (p.y  > (offset+0.001f)))
										ignoreFaces.Set(i);
								else if ((axis == kZ) && (p.z  > (offset+0.001f)))
									ignoreFaces.Set(i);
								}
							else
								{
								if ((axis == kX) && (p.x < (offset-0.001f)))
									ignoreFaces.Set(i);
								else if ((axis == kY) && (p.y  < (offset-0.001f)))
										ignoreFaces.Set(i);
								else if ((axis == kZ) && (p.z  < (offset-0.001f)))
									ignoreFaces.Set(i);
								}


							}
						}
					}


				for (i =0; i < numFaces; i++)
					{
					if ((!faceSel[i]) && (!ignoreFaces[i]))
						{
						for (int j = 0; j < 3; j++)
							{
							int a = mesh.faces[i].v[j];
							gUVWs[a] = uvw[tvFaces[i].t[j]];
							usedgUVWs.Set(a);
							}
						}
					}
//more butt ugly code coming
//loo through left over faces 
				
				Tab <Point3> strayVerts;
				int strayStart = mesh.getNumMapVerts(channel);
				int initStart = mesh.getNumMapVerts(channel);
				for (i = 0; i < numFaces; i++)
					{
					if (faceSel[i]) 
						{
						int hitCount = 0;
						int vids[3];
						for (int j = 0; j < 3; j++)
							{
							float closestD = -1.0f;
							int closestIndex = -1;
							int a = mesh.faces[i].v[j];
							Point3 p, mp;
							p = mirrorVerts[a];

							for (int k =0; k < numVerts; k++)
								{
								if (usedgUVWs[k])
									{
									mp = verts[k];
									float d = Length(mp-p);
									if ((closestIndex == -1) || (d < closestD))
										{
										closestD = d;
										closestIndex = k;
										}
									}
								}
							if (closestD < threshold)
								{
								vids[j] = closestIndex;
								hitCount++;
								}
							}
						if (hitCount == 3)
							{
							int a = vids[0];
							strayDisplayVerts.Append(1,&verts[a],500); 
							strayVerts.Append(1,&gUVWs[a],500);
							a = vids[1];
							strayDisplayVerts.Append(1,&verts[a],500); 
							strayVerts.Append(1,&gUVWs[a],500);
							a = vids[2];
							strayDisplayVerts.Append(1,&verts[a],500); 
							strayVerts.Append(1,&gUVWs[a],500);
							tvFaces[i].t[0] = strayStart++;
							tvFaces[i].t[1] = strayStart++;
							tvFaces[i].t[2] = strayStart++;
							}
						}
					}

				mesh.setNumMapVerts(channel,strayStart , TRUE);
				int ct = 0;
				
				for (i = initStart; i < strayStart; i++)
					{
					mesh.setMapVert(channel, i, strayVerts[ct]);					
					ct++;
					}


				}

			iv.Set(t,t); 
			os->obj->UpdateValidity(TEXMAP_CHAN_NUM,iv);
			os->obj->UpdateValidity(GEOM_CHAN_NUM,iv);
			os->obj->UpdateValidity(TOPO_CHAN_NUM,iv);

//			for (i =0; i < numVerts; i++)
//				mirrorVerts[i] = mirrorVerts[i] * backtm;
			}
		}
}


void MirrorTVs::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	this->ip = ip;
	TimeValue t = ip->GetTime();
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_BEGIN_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_ON);
	SetAFlag(A_MOD_BEING_EDITED);
	MirrorTVsDesc.BeginEditParams(ip, this, flags, prev);
}

void MirrorTVs::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	MirrorTVsDesc.EndEditParams(ip, this, flags, next);
	TimeValue t = ip->GetTime();
	ClearAFlag(A_MOD_BEING_EDITED);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_END_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_OFF);
	this->ip = NULL;
	mirrorVerts.ZeroCount();
	strayDisplayVerts.ZeroCount();
	mirrorFaces.ZeroCount();
}



Interval MirrorTVs::GetValidity(TimeValue t)
{
	Interval valid = FOREVER;
	//TODO: Return the validity interval of the modifier
	valid.Set(t,t);
	return valid;
}




RefTargetHandle MirrorTVs::Clone(RemapDir& remap)
{
	MirrorTVs* newmod = new MirrorTVs();	
	//TODO: Add the cloning code here
	newmod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
	BaseClone(this, newmod, remap);
	return(newmod);
}


//From ReferenceMaker 
RefResult MirrorTVs::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 
{
	//TODO: Add code to handle the various reference changed messages
	return REF_SUCCEED;
}

/****************************************************************************************
*
 	NotifyInputChanged is called each time the input object is changed in some way
 	We can find out how it was changed by checking partID and message
*
\****************************************************************************************/

void MirrorTVs::NotifyInputChanged(Interval changeInt, PartID partID, RefMessage message, ModContext *mc)
{

}



//From Object
BOOL MirrorTVs::HasUVW() 
{ 
	//TODO: Return whether the object has UVW coordinates or not
	return TRUE; 
}

void MirrorTVs::SetGenUVW(BOOL sw) 
{  
	if (sw==HasUVW()) return;
	//TODO: Set the plugin internal value to sw				
}

IOResult MirrorTVs::Load(ILoad *iload)
{
	//TODO: Add code to allow plugin to load its data
	
	return IO_OK;
}

IOResult MirrorTVs::Save(ISave *isave)
{
	//TODO: Add code to allow plugin to save its data
	
	return IO_OK;
}

int MirrorTVs::NumSubObjTypes() 
{ 
	return 1;
}

ISubObjType *MirrorTVs::GetSubObjType(int i) 
{

	static bool initialized = false;
	if(!initialized)
	{
		initialized = true;
		SOT_Points.SetName(GetString(IDS_MIRROR));
	}

	switch(i)
	{
	case 0:
		return &SOT_Points;
	}
	return NULL;
}
